import twitter4j.TwitterFactory
import twitter4j.auth.AccessToken;
import twitter4j.Query;
import twitter4j.GeoLocation;
import twitter4j.Status;
import scala.collection.JavaConversions._
import scala.math._


val consumerKey = "YOUR_INFO"
val consumerSecret = "YOUR_INFO"
val accessToken = "YOUR_INFO"
val accessTokenSecret = "YOUR_INFO"



val twitter = new TwitterFactory().getInstance()
  // Authorising with your Twitter Application credentials
twitter.setOAuthConsumer(consumerKey,consumerSecret)
twitter.setOAuthAccessToken(new AccessToken(accessToken, accessTokenSecret))

def isPlausiblyILI(strTweetText: String) : Boolean = {  strTweetText.contains("the flu") || strTweetText.contains("influenza") || strTweetText.contains("bad cold") || strTweetText.contains("a flu") || strTweetText.contains("sneez") || strTweetText.contains("cough") || strTweetText.contains("body ache") || strTweetText.contains("fever") }


val maxDesiredTweets = 100000  // place an upperbound on our tweets
var countTweetsRemainingUpperBound = maxDesiredTweets

// search the area around Boston
val baseQuery = new Query().geoCode(new GeoLocation(42.3601, -71.0), 100, "mi").since("2016-11-10")
var minIdSeenSoFar: Long = -1
val maxAllowableTweetsInBatchForAPI = 100
var countTweetsReceived = 0
var countPlausiblyILITweetsReceived = 0

while (countTweetsRemainingUpperBound > 0)
    {   
    val attemptedTweets = min(maxAllowableTweetsInBatchForAPI, countTweetsRemainingUpperBound)
    val query = baseQuery.count(attemptedTweets).maxId(minIdSeenSoFar - 1) // query up to the min id seen this far (i.e., up to just before the last id retrieved), but no more than countTweetsRemainingUpperBound
    val results = twitter.search(query)
    val countTweetsRetrievedInBatch = results.getTweets.size
    minIdSeenSoFar = results.getTweets.get(countTweetsRetrievedInBatch - 1).getId   // record the minimum id seen in this batch, so that we can use it for the next batch
    
//    results.getTweets.foreach((status:Status) => println(status.getText + "\n--------------------------"))
    countPlausiblyILITweetsReceived += results.getTweets.filter((status:Status) => isPlausiblyILI(status.getText)).size
    
    countTweetsReceived += countTweetsRetrievedInBatch
    if (countTweetsRetrievedInBatch < attemptedTweets)  // if we got back fewer tweets than requested, we must have exhausted the available tweets
        countTweetsRemainingUpperBound = 0;
    else
        countTweetsRemainingUpperBound -= countTweetsRetrievedInBatch     // note that countTweetsRetrievedInBatch cannot be greater than 
    }

println(s"Total tweets received $countTweetsReceived, of which $countPlausiblyILITweetsReceived are of possible influenza-like illness");



